import es
import gamethread
import langlib
import os.path
import playerlib


info = es.AddonInfo()
info.name = 'ProtectionSpawn'
info.version = '1.0'
info.author = 'Sponko'

###Pour configurer l'addon, rendez vous dans le fichier ProtectionSpawn.cfg###

dict_players = {}

dict_options = {'spawn_protection_time':[4, 'Nombre de secondes de la protection au spawn des joueurs (doit etre superieur ou egal a 1)'], 'spawn_protection_health':[0, 'Montant de vie simule pour un joueur invincible (jusque 511hp), mettre a 0 pour ne pas afficher de vie'], 'spawn_protection_slay':[0, '0 = ne pas activer, 1 = tuer les joueurs qui attaquent un joueur invincible'], 'spawn_protection_loseondamage':[1, '0 = gardent l\'invincibilite jusqu\'a la fin de la protection, 1 = le joueur perds son invincibile quand il causera des dommages et avant meme la fin du temps de protection'], 'spawn_fade_alpha':[100, 'Valeur Alpha a donner aux joueurs quand ils sont invincibles'], 'spawn_fade_steps':[5, 'nombre de pas avant que l\'invisiblite ,pendant le temps de protection, ne se dissipe'], 'spawn_announce_start_console':[0, '0 = ne pas activer, 1 = annoncer au joueur dans la console quand il ou elle est invincible, 2 = annoncer a tous les joueurs sur le serveur dans leur console quand  un joueur est invincible'], 'spawn_announce_start_chat':[0, '0 = ne pas activer, 1 = annoncer au joueur dans le chat quand il ou elle devient invincible, 2 = annoncer a tous les joueurs sur le serveur dans le chat quand un joueur est invncible'], 'spawn_announce_start_center':[1, '0 = ne pas activer, 1 = annoncer au joueur au centre de son ecran quand il est invincible, 2 = annoncer a tous les joueurs au centre de leur ecran quand un joueur est invincible'], 'spawn_announce_end_console':[0, '0 = ne pas activer, 1 = annoncer au joueur dans la console quand il ou elle n\'est plus invincible, 2 = annoncer a tous les joueurs dans leur console quand un joueur n\'est plus invincible'], 'spawn_announce_end_chat':[0 ,'0 = ne pas activer, 1 = annoncer au joueur dans le chat quand il ou elle n\'est plus invincible, 2 = annoncer a tous les joueurs dans le chat quand un joueur n\'est plus invincible'], 'spawn_announce_end_center':[1, '0 = ne pas activer, 1 = annoncer au joueur au centre de son ecran quand il ou elle n\'est plus invincible, 2 = annoncer a tous les joueurs au centre de leur ecran quand un joueur n\'est plus invincible'], 'spawn_announce_slay_console':[0, '0 = ne pas activer, 1 = annoncer au joueur dans la console quand il ou elle a ete puni pour avoir attaque un joueur invincible, 2 = annoncer a tous les joueurs dans leur console quand un joueur est puni pour avoir attaque un joueur invincible'], 'spawn_announce_slay_chat':[2, '0 = ne pas activer, 1 = annoncer au joueur dans le chat quand il ou elle a ete puni pour avoir attaque un joueur invincible, 2 = annoncer a tous les joueurs dans le chat quand un joueur est puni pour avoir attaque un joueur invincible'], 'spawn_announce_slay_center':[1, '0 = ne pas activer, 1 = annoncer au joueur au centre de son ecran quand il ou elle a ete puni pour avoir attaque un joueur invincible, 2 = annoncer a tous les joueurs au centre de leur ecran quand un joueur a ete puni pour avoir attaque un joueur invincible']}
func_lang_text = None


def load():
   global func_lang_text

   for str_option in dict_options:
      es.ServerVar(str_option, dict_options[str_option][0], dict_options[str_option][1])
   if os.path.isfile(es.getAddonPath('ProtectionSpawn') + '/ProtectionSpawn.cfg'):
      es.server.cmd('es_xmexec ../addons/eventscripts/ProtectionSpawn/ProtectionSpawn.cfg')
   else:
      es.dbgmsg(0, '[ProtectionSpawn by Sponko]: Unable to load ProtectionSpawn.cfg! Please ensure it is in the ./ProtectionSpawn/ directory.')

   str_lang_path = es.getAddonPath('ProtectionSpawn') + '/ProtectionSpawn_languages.ini'
   if os.path.isfile(str_lang_path):
      func_lang_text = langlib.Strings(str_lang_path)
   else:
      es.dbgmsg(0, '[ProtectionSpawn by Sponko]: Unable to load ProtectionSpawn_languages.ini! Please ensure it is in the ./ProtectionSpawn/ directory.')
   if not func_lang_text:
      func_lang_text = missing_lang


def player_spawn(event_var):
   global dict_players

   str_userid = event_var['userid']
   if dict_players.has_key(str_userid):
      gamethread.cancelDelayed('spawn_%s' % str_userid)

   es.server.cmd('es_xfire %s !self addoutput \"rendermode 1"' % str_userid)
   int_fade_alpha = int(es.ServerVar('spawn_fade_alpha'))
   if int_fade_alpha <> 255:
      es.server.cmd('es_xfire %s !self alpha %s' % (str_userid, int_fade_alpha))

   int_steps = int(es.ServerVar('spawn_fade_steps'))
   float_protection_time = float(es.ServerVar('spawn_protection_time'))
   if int_steps:
      float_interval = float_protection_time / float(int_steps)
   else:
      float_interval = float_protection_time

   display_message(str_userid, 'start', {'time':float_protection_time})
   dict_players[str_userid] = {'interval':float_interval, 'health':int(event_var['es_userhealth']), 'armor':int(event_var['es_userarmor']), 'protection_health':1024 + es.ServerVar('spawn_protection_health'), 'step':-1, 'total_steps':int_steps, 'alpha':int_fade_alpha}
   gamethread.delayedname(0.1, 'spawn_%s' % str_userid, spawn_step, str_userid)


def player_hurt(event_var):
   global dict_players

   str_userid = event_var['userid']
   str_attacker = event_var['attacker']
   if dict_players.has_key(str_userid):
      es.setplayerprop(str_userid, 'CBasePlayer.m_iHealth', dict_players[str_userid]['protection_health'])
      es.setplayerprop(str_userid, 'CCSPlayer.m_ArmorValue', dict_players[str_userid]['armor'])

      if int(es.ServerVar('spawn_protection_slay')) and int(str_attacker):
         es.cexec(str_attacker, 'kill')
         display_message(str_userid, 'slay', {'player':event_var['es_attackername'], 'victim':event_var['es_username']})
   elif dict_players.has_key(str_attacker) and int(es.ServerVar('spawn_protection_loseondamage')):
      dict_players[str_attacker]['steps'] = dict_players[str_attacker]['total_steps']
      gamethread.cancelDelayed('spawn_%s' % str_attacker)
      spawn_step(str_attacker)


def player_death(event_var):
   player_disconnect(event_var)


def player_disconnect(event_var):
   global dict_players

   str_userid = event_var['userid']
   if dict_players.has_key(str_userid):
      gamethread.cancelDelayed('spawn_%s' % str_userid)
      del dict_players[str_userid]


def unload():
   int_fade_alpha = int(es.ServerVar('spawn_fade_alpha'))
   for str_userid in dict_players:
      gamethread.cancelDelayed('spawn_%s' % str_userid)
      es.setplayerprop(str_userid, 'CBasePlayer.m_iHealth', dict_players[str_userid]['health'])
      if dict_players[str_userid]['alpha'] <> 255:
         es.server.cmd('es_xfire %s !self alpha 255' % str_userid)

   for str_option in dict_options:
      es.ServerVar(str_option).set(0)


def spawn_step(str_userid):
   global dict_players

   int_health = es.getplayerprop(str_userid, 'CBasePlayer.m_iHealth')
   dict_current_player = dict_players[str_userid]
   dict_current_player['step'] += 1

   if int_health <> dict_current_player['protection_health']:
      dict_current_player['health'] = int_health
      es.setplayerprop(str_userid, 'CBasePlayer.m_iHealth', dict_current_player['protection_health'])
   int_armor = es.getplayerprop(str_userid, 'CCSPlayer.m_ArmorValue')
   if int_armor <> dict_current_player['armor']:
      dict_current_player['armor'] = int_armor

   if dict_current_player['step'] >= dict_current_player['total_steps']:
      display_message(str_userid, 'end', {'player':es.getplayername(str_userid)})
      es.setplayerprop(str_userid, 'CBasePlayer.m_iHealth', dict_current_player['health'])
      es.setplayerprop(str_userid, 'CCSPlayer.m_ArmorValue', dict_current_player['armor'])
      if dict_current_player['alpha'] <> 255:
         es.server.cmd('es_xfire %s !self alpha 255' % str_userid)
      del dict_players[str_userid]
   else:
      if dict_current_player['alpha'] <> 255:
         es.server.cmd('es_xfire %s !self alpha %s' % (str_userid, int(((255 - dict_current_player['alpha']) * dict_current_player['step']) / dict_current_player['total_steps']) + dict_current_player['alpha']))
      gamethread.delayedname(dict_current_player['interval'], 'spawn_%s' % str_userid, spawn_step, str_userid)


def display_message(str_userid, str_event, dict_tokens):
   str_user_lang = playerlib.getPlayer(str_userid).get('lang')

   int_display = int(es.ServerVar('spawn_announce_' + str_event  + '_console'))
   if int_display == 2:
      for int_loop_userid in es.getUseridList():
          es.cexec(int_loop_userid, 'echo ' + remove_tags(func_lang_text('invincible ' + str_event + ' all', dict_tokens, playerlib.getPlayer(int_loop_userid).get('lang'))))
   elif int_display:
      es.cexec(str_userid, 'echo ' + remove_tags(func_lang_text('invincible ' + str_event, dict_tokens, str_user_lang)))

   int_display = int(es.ServerVar('spawn_announce_' + str_event  + '_chat'))
   if int_display == 2:
      for int_loop_userid in es.getUseridList():
          es.tell(int_loop_userid, '#multi', func_lang_text('invincible ' + str_event + ' all', dict_tokens, playerlib.getPlayer(int_loop_userid).get('lang')))
   elif int_display:
      es.tell(str_userid, '#multi', func_lang_text('invincible ' + str_event, dict_tokens, str_user_lang))

   int_display = int(es.ServerVar('spawn_announce_' + str_event  + '_center'))
   if int_display == 2:
      for int_loop_userid in es.getUseridList():
          es.centertell(int_loop_userid, remove_tags(func_lang_text('invincible ' + str_event + ' all', dict_tokens, playerlib.getPlayer(int_loop_userid).get('lang'))))
   elif int_display:
      es.centertell(str_userid, remove_tags(func_lang_text('invincible ' + str_event, dict_tokens, str_user_lang)))


def remove_tags(str_text):
   return str_text.replace('#lightgreen', '').replace('#green', '').replace('#default', '')


def missing_lang(str_heading, dict_tokens, str_language):
   return '[ProtectionSpawn by Sponko]: ProtectionSpawn_languages.ini introuvable !'